#ifndef _H_96A138A13EE2BB35F544151D697893F4_Dock__H_
#define _H_96A138A13EE2BB35F544151D697893F4_Dock__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            struct  Dock_Goal_
            {
                ::DDS::Boolean dock_;
            };

            typedef DDS_DCPSStruct_var<Dock_Goal_> Dock_Goal__var;
            typedef Dock_Goal_& Dock_Goal__out;

            struct  Dock_SendGoal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::py_trees_ros_interfaces::action::dds_::Dock_Goal_ goal_;
            };

            typedef DDS_DCPSStruct_var<Dock_SendGoal_Request_> Dock_SendGoal_Request__var;
            typedef Dock_SendGoal_Request_& Dock_SendGoal_Request__out;

            struct  Dock_SendGoal_Response_
            {
                ::DDS::Boolean accepted_;
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
            };

            typedef DDS_DCPSStruct_var<Dock_SendGoal_Response_> Dock_SendGoal_Response__var;
            typedef Dock_SendGoal_Response_& Dock_SendGoal_Response__out;

            struct  Sample_Dock_SendGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::action::dds_::Dock_SendGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dock_SendGoal_Request_> Sample_Dock_SendGoal_Request__var;
            typedef Sample_Dock_SendGoal_Request_& Sample_Dock_SendGoal_Request__out;

            struct  Sample_Dock_SendGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::action::dds_::Dock_SendGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dock_SendGoal_Response_> Sample_Dock_SendGoal_Response__var;
            typedef Sample_Dock_SendGoal_Response_& Sample_Dock_SendGoal_Response__out;

            struct  Dock_Result_
            {
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<Dock_Result_> Dock_Result__var;
            typedef DDS_DCPSStruct_out < Dock_Result_> Dock_Result__out;

            struct  Dock_GetResult_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
            };

            typedef DDS_DCPSStruct_var<Dock_GetResult_Request_> Dock_GetResult_Request__var;
            typedef Dock_GetResult_Request_& Dock_GetResult_Request__out;

            struct  Dock_GetResult_Response_
            {
                ::DDS::Octet status_;
                ::py_trees_ros_interfaces::action::dds_::Dock_Result_ result_;
            };

            typedef DDS_DCPSStruct_var<Dock_GetResult_Response_> Dock_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < Dock_GetResult_Response_> Dock_GetResult_Response__out;

            struct  Sample_Dock_GetResult_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::action::dds_::Dock_GetResult_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dock_GetResult_Request_> Sample_Dock_GetResult_Request__var;
            typedef Sample_Dock_GetResult_Request_& Sample_Dock_GetResult_Request__out;

            struct  Sample_Dock_GetResult_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::action::dds_::Dock_GetResult_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Dock_GetResult_Response_> Sample_Dock_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Dock_GetResult_Response_> Sample_Dock_GetResult_Response__out;

            struct  Dock_Feedback_
            {
                ::DDS::Float percentage_completed_;
            };

            typedef DDS_DCPSStruct_var<Dock_Feedback_> Dock_Feedback__var;
            typedef Dock_Feedback_& Dock_Feedback__out;

            struct  Dock_FeedbackMessage_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::py_trees_ros_interfaces::action::dds_::Dock_Feedback_ feedback_;
            };

            typedef DDS_DCPSStruct_var<Dock_FeedbackMessage_> Dock_FeedbackMessage__var;
            typedef Dock_FeedbackMessage_& Dock_FeedbackMessage__out;

        }

    }

}

#endif /* _H_96A138A13EE2BB35F544151D697893F4_Dock__H_ */
