#ifndef H_96A138A13EE2BB35F544151D697893F4_Dock_SPLTYPES_H
#define H_96A138A13EE2BB35F544151D697893F4_Dock_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Dock_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __Dock__py_trees_ros_interfaces__load (c_base base);

extern c_metaObject __Dock__py_trees_ros_interfaces_action__load (c_base base);

extern c_metaObject __Dock__py_trees_ros_interfaces_action_dds___load (c_base base);

extern const char *py_trees_ros_interfaces_action_dds__Dock_Goal__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_Goal__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_Goal__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_Goal___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_Goal_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_Goal___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_Goal_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_Goal_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_Goal___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_Goal_ {
    c_bool dock_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__Dock_Goal_ goal_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Dock_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Dock_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Dock_SendGoal_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_Result__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_Result__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_Result__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_Result___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_Result_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_Result___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_Result_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_Result_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_Result___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_Result_ {
    c_string message_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Response_ {
    c_octet status_;
    struct _py_trees_ros_interfaces_action_dds__Dock_Result_ result_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Dock_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Dock_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Dock_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Dock_GetResult_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_Feedback__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_Feedback__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_Feedback__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_Feedback___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_Feedback_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_Feedback___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_Feedback_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_Feedback_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_Feedback___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_Feedback_ {
    c_float percentage_completed_;
};

extern const char *py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Dock_FeedbackMessage_ *from, struct _py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Dock_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__Dock_Feedback_ feedback_;
};

#undef OS_API
#endif
