#ifndef H_A0355636CC9FE1672FD1F2984C0DD419_MoveBase_SPLTYPES_H
#define H_A0355636CC9FE1672FD1F2984C0DD419_MoveBase_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_MoveBase_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __MoveBase__py_trees_ros_interfaces__load (c_base base);

extern c_metaObject __MoveBase__py_trees_ros_interfaces_action__load (c_base base);

extern c_metaObject __MoveBase__py_trees_ros_interfaces_action_dds___load (c_base base);

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_Goal__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Goal__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Goal__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_Goal___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Goal_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_Goal___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_Goal_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_Goal_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_Goal___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Goal_ {
    struct _geometry_msgs_msg_dds__PoseStamped_ target_pose_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_Goal_ goal_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_MoveBase_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_MoveBase_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_SendGoal_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_Result__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Result__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Result__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_Result___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Result_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_Result___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_Result_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_Result_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_Result___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Result_ {
    c_string message_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response_ {
    c_octet status_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_Result_ result_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_MoveBase_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_MoveBase_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_MoveBase_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_GetResult_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_Feedback__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Feedback__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_Feedback__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_Feedback___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Feedback_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_Feedback___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_Feedback_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_Feedback_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_Feedback___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_Feedback_ {
    struct _geometry_msgs_msg_dds__PoseStamped_ base_position_;
};

extern const char *py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::MoveBase_FeedbackMessage_ *from, struct _py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage_ *to);
extern  void __py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__MoveBase_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__MoveBase_Feedback_ feedback_;
};

#undef OS_API
#endif
