#ifndef H_5F98C18CFBED07723E4E24EC4DEFDDD2_Rotate_SPLTYPES_H
#define H_5F98C18CFBED07723E4E24EC4DEFDDD2_Rotate_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Rotate_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __Rotate__py_trees_ros_interfaces__load (c_base base);

extern c_metaObject __Rotate__py_trees_ros_interfaces_action__load (c_base base);

extern c_metaObject __Rotate__py_trees_ros_interfaces_action_dds___load (c_base base);

extern const char *py_trees_ros_interfaces_action_dds__Rotate_Goal__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_Goal__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_Goal__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_Goal___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_Goal_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_Goal___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_Goal_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_Goal_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_Goal___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_Goal_ {
    c_octet structure_needs_at_least_one_member_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_Goal_ goal_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Rotate_SendGoal_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Rotate_SendGoal_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_SendGoal_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_Result__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_Result__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_Result__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_Result___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_Result_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_Result___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_Result_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_Result_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_Result___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_Result_ {
    c_string message_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response_ {
    c_octet status_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_Result_ result_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Rotate_GetResult_Request_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Request_ request_;
};

extern const char *py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Sample_Rotate_GetResult_Response_ *from, struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Sample_Rotate_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_GetResult_Response_ response_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_Feedback__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_Feedback__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_Feedback__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_Feedback___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_Feedback_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_Feedback___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_Feedback_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_Feedback_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_Feedback___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_Feedback_ {
    c_float percentage_completed_;
    c_float angle_rotated_;
};

extern const char *py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage__metaDescriptor[];
extern const int py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage__metaDescriptorArrLength;
extern const int py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage___load (c_base base);
struct _py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage_ ;
extern  v_copyin_result __py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage___copyIn(c_base base, const struct py_trees_ros_interfaces::action::dds_::Rotate_FeedbackMessage_ *from, struct _py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage_ *to);
extern  void __py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _py_trees_ros_interfaces_action_dds__Rotate_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _py_trees_ros_interfaces_action_dds__Rotate_Feedback_ feedback_;
};

#undef OS_API
#endif
