// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from py_trees_ros_interfaces:msg/Behaviour.idl
// generated code does not contain a copyright notice
#include "py_trees_ros_interfaces/msg/behaviour__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `name`
// Member `class_name`
// Member `message`
#include "rosidl_generator_c/string_functions.h"
// Member `own_id`
// Member `parent_id`
// Member `tip_id`
// Member `child_ids`
// Member `current_child_id`
#include "unique_identifier_msgs/msg/uuid__functions.h"

bool
py_trees_ros_interfaces__msg__Behaviour__init(py_trees_ros_interfaces__msg__Behaviour * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_generator_c__String__init(&msg->name)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // class_name
  if (!rosidl_generator_c__String__init(&msg->class_name)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // own_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->own_id)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // parent_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->parent_id)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // tip_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->tip_id)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // child_ids
  if (!unique_identifier_msgs__msg__UUID__Sequence__init(&msg->child_ids, 0)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // current_child_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->current_child_id)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // type
  // blackbox_level
  // status
  // message
  if (!rosidl_generator_c__String__init(&msg->message)) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
    return false;
  }
  // is_active
  return true;
}

void
py_trees_ros_interfaces__msg__Behaviour__fini(py_trees_ros_interfaces__msg__Behaviour * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_generator_c__String__fini(&msg->name);
  // class_name
  rosidl_generator_c__String__fini(&msg->class_name);
  // own_id
  unique_identifier_msgs__msg__UUID__fini(&msg->own_id);
  // parent_id
  unique_identifier_msgs__msg__UUID__fini(&msg->parent_id);
  // tip_id
  unique_identifier_msgs__msg__UUID__fini(&msg->tip_id);
  // child_ids
  unique_identifier_msgs__msg__UUID__Sequence__fini(&msg->child_ids);
  // current_child_id
  unique_identifier_msgs__msg__UUID__fini(&msg->current_child_id);
  // type
  // blackbox_level
  // status
  // message
  rosidl_generator_c__String__fini(&msg->message);
  // is_active
}

py_trees_ros_interfaces__msg__Behaviour *
py_trees_ros_interfaces__msg__Behaviour__create()
{
  py_trees_ros_interfaces__msg__Behaviour * msg = (py_trees_ros_interfaces__msg__Behaviour *)malloc(sizeof(py_trees_ros_interfaces__msg__Behaviour));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(py_trees_ros_interfaces__msg__Behaviour));
  bool success = py_trees_ros_interfaces__msg__Behaviour__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
py_trees_ros_interfaces__msg__Behaviour__destroy(py_trees_ros_interfaces__msg__Behaviour * msg)
{
  if (msg) {
    py_trees_ros_interfaces__msg__Behaviour__fini(msg);
  }
  free(msg);
}


bool
py_trees_ros_interfaces__msg__Behaviour__Sequence__init(py_trees_ros_interfaces__msg__Behaviour__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  py_trees_ros_interfaces__msg__Behaviour * data = NULL;
  if (size) {
    data = (py_trees_ros_interfaces__msg__Behaviour *)calloc(size, sizeof(py_trees_ros_interfaces__msg__Behaviour));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = py_trees_ros_interfaces__msg__Behaviour__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        py_trees_ros_interfaces__msg__Behaviour__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
py_trees_ros_interfaces__msg__Behaviour__Sequence__fini(py_trees_ros_interfaces__msg__Behaviour__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      py_trees_ros_interfaces__msg__Behaviour__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

py_trees_ros_interfaces__msg__Behaviour__Sequence *
py_trees_ros_interfaces__msg__Behaviour__Sequence__create(size_t size)
{
  py_trees_ros_interfaces__msg__Behaviour__Sequence * array = (py_trees_ros_interfaces__msg__Behaviour__Sequence *)malloc(sizeof(py_trees_ros_interfaces__msg__Behaviour__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = py_trees_ros_interfaces__msg__Behaviour__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
py_trees_ros_interfaces__msg__Behaviour__Sequence__destroy(py_trees_ros_interfaces__msg__Behaviour__Sequence * array)
{
  if (array) {
    py_trees_ros_interfaces__msg__Behaviour__Sequence__fini(array);
  }
  free(array);
}
