#ifndef _H_15A2F3BC0C38CC0E5DB0526989C3DF7D_SubscriberDetails_DCPS_H_
#define _H_15A2F3BC0C38CC0E5DB0526989C3DF7D_SubscriberDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SubscriberDetails_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class SubscriberDetails_TypeSupportInterface;

            typedef SubscriberDetails_TypeSupportInterface * SubscriberDetails_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SubscriberDetails_TypeSupportInterface> SubscriberDetails_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SubscriberDetails_TypeSupportInterface> SubscriberDetails_TypeSupportInterface_out;


            class SubscriberDetails_DataWriter;

            typedef SubscriberDetails_DataWriter * SubscriberDetails_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SubscriberDetails_DataWriter> SubscriberDetails_DataWriter_var;
            typedef DDS_DCPSInterface_out < SubscriberDetails_DataWriter> SubscriberDetails_DataWriter_out;


            class SubscriberDetails_DataReader;

            typedef SubscriberDetails_DataReader * SubscriberDetails_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SubscriberDetails_DataReader> SubscriberDetails_DataReader_var;
            typedef DDS_DCPSInterface_out < SubscriberDetails_DataReader> SubscriberDetails_DataReader_out;


            class SubscriberDetails_DataReaderView;

            typedef SubscriberDetails_DataReaderView * SubscriberDetails_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SubscriberDetails_DataReaderView> SubscriberDetails_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SubscriberDetails_DataReaderView> SubscriberDetails_DataReaderView_out;

            struct SubscriberDetails_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SubscriberDetails_, struct SubscriberDetails_Seq_uniq_> SubscriberDetails_Seq;
            typedef DDS_DCPSSequence_var < SubscriberDetails_Seq> SubscriberDetails_Seq_var;
            typedef DDS_DCPSSequence_out < SubscriberDetails_Seq> SubscriberDetails_Seq_out;

            class  SubscriberDetails_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SubscriberDetails_TypeSupportInterface_ptr _ptr_type;
                typedef SubscriberDetails_TypeSupportInterface_var _var_type;

                static SubscriberDetails_TypeSupportInterface_ptr _duplicate (SubscriberDetails_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubscriberDetails_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SubscriberDetails_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubscriberDetails_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SubscriberDetails_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SubscriberDetails_TypeSupportInterface () {};
                ~SubscriberDetails_TypeSupportInterface () {};
            private:
                SubscriberDetails_TypeSupportInterface (const SubscriberDetails_TypeSupportInterface &);
                SubscriberDetails_TypeSupportInterface & operator = (const SubscriberDetails_TypeSupportInterface &);
            };

            class  SubscriberDetails_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SubscriberDetails_DataWriter_ptr _ptr_type;
                typedef SubscriberDetails_DataWriter_var _var_type;

                static SubscriberDetails_DataWriter_ptr _duplicate (SubscriberDetails_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubscriberDetails_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SubscriberDetails_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SubscriberDetails_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SubscriberDetails_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SubscriberDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SubscriberDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SubscriberDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SubscriberDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SubscriberDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SubscriberDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SubscriberDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SubscriberDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SubscriberDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubscriberDetails_& instance_data) = 0;

            protected:
                SubscriberDetails_DataWriter () {};
                ~SubscriberDetails_DataWriter () {};
            private:
                SubscriberDetails_DataWriter (const SubscriberDetails_DataWriter &);
                SubscriberDetails_DataWriter & operator = (const SubscriberDetails_DataWriter &);
            };

            class  SubscriberDetails_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SubscriberDetails_DataReader_ptr _ptr_type;
                typedef SubscriberDetails_DataReader_var _var_type;

                static SubscriberDetails_DataReader_ptr _duplicate (SubscriberDetails_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubscriberDetails_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SubscriberDetails_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SubscriberDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SubscriberDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SubscriberDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubscriberDetails_& instance) = 0;

            protected:
                SubscriberDetails_DataReader () {};
                ~SubscriberDetails_DataReader () {};
            private:
                SubscriberDetails_DataReader (const SubscriberDetails_DataReader &);
                SubscriberDetails_DataReader & operator = (const SubscriberDetails_DataReader &);
            };

            class  SubscriberDetails_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SubscriberDetails_DataReaderView_ptr _ptr_type;
                typedef SubscriberDetails_DataReaderView_var _var_type;

                static SubscriberDetails_DataReaderView_ptr _duplicate (SubscriberDetails_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SubscriberDetails_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SubscriberDetails_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SubscriberDetails_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SubscriberDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SubscriberDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SubscriberDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SubscriberDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SubscriberDetails_& instance) = 0;

            protected:
                SubscriberDetails_DataReaderView () {};
                ~SubscriberDetails_DataReaderView () {};
            private:
                SubscriberDetails_DataReaderView (const SubscriberDetails_DataReaderView &);
                SubscriberDetails_DataReaderView & operator = (const SubscriberDetails_DataReaderView &);
            };
        }

    }

}

#endif
