#ifndef _H_25C31FC2351662334F9A1D62939BD44B_GetBlackboardVariables__H_
#define _H_25C31FC2351662334F9A1D62939BD44B_GetBlackboardVariables__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetBlackboardVariables_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetBlackboardVariables_Request_> GetBlackboardVariables_Request__var;
            typedef GetBlackboardVariables_Request_& GetBlackboardVariables_Request__out;

            struct  GetBlackboardVariables_Response_
            {
                struct _variables__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _variables__seq_uniq_ > _variables__seq;
                typedef DDS_DCPSUStrSeq_var< _variables__seq > _variables__seq_var;
                typedef DDS_DCPSUStrSeq_out< _variables__seq > _variables__seq_out;
                _variables__seq variables_;
            };

            typedef DDS_DCPSStruct_var<GetBlackboardVariables_Response_> GetBlackboardVariables_Response__var;
            typedef DDS_DCPSStruct_out < GetBlackboardVariables_Response_> GetBlackboardVariables_Response__out;

            struct  Sample_GetBlackboardVariables_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::GetBlackboardVariables_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetBlackboardVariables_Request_> Sample_GetBlackboardVariables_Request__var;
            typedef Sample_GetBlackboardVariables_Request_& Sample_GetBlackboardVariables_Request__out;

            struct  Sample_GetBlackboardVariables_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::GetBlackboardVariables_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetBlackboardVariables_Response_> Sample_GetBlackboardVariables_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetBlackboardVariables_Response_> Sample_GetBlackboardVariables_Response__out;

        }

    }

}

#endif /* _H_25C31FC2351662334F9A1D62939BD44B_GetBlackboardVariables__H_ */
