#ifndef _H_637F9E3CAB28AEE5FFF2B94214E25609_IntrospectPublishers_DCPS_H_
#define _H_637F9E3CAB28AEE5FFF2B94214E25609_IntrospectPublishers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IntrospectPublishers_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class IntrospectPublishers_Request_TypeSupportInterface;

            typedef IntrospectPublishers_Request_TypeSupportInterface * IntrospectPublishers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_TypeSupportInterface> IntrospectPublishers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_TypeSupportInterface> IntrospectPublishers_Request_TypeSupportInterface_out;


            class IntrospectPublishers_Request_DataWriter;

            typedef IntrospectPublishers_Request_DataWriter * IntrospectPublishers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataWriter> IntrospectPublishers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataWriter> IntrospectPublishers_Request_DataWriter_out;


            class IntrospectPublishers_Request_DataReader;

            typedef IntrospectPublishers_Request_DataReader * IntrospectPublishers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataReader> IntrospectPublishers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataReader> IntrospectPublishers_Request_DataReader_out;


            class IntrospectPublishers_Request_DataReaderView;

            typedef IntrospectPublishers_Request_DataReaderView * IntrospectPublishers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataReaderView> IntrospectPublishers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataReaderView> IntrospectPublishers_Request_DataReaderView_out;

            struct IntrospectPublishers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IntrospectPublishers_Request_, struct IntrospectPublishers_Request_Seq_uniq_> IntrospectPublishers_Request_Seq;
            typedef DDS_DCPSSequence_var < IntrospectPublishers_Request_Seq> IntrospectPublishers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectPublishers_Request_Seq> IntrospectPublishers_Request_Seq_out;

            class  IntrospectPublishers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectPublishers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectPublishers_Request_TypeSupportInterface_var _var_type;

                static IntrospectPublishers_Request_TypeSupportInterface_ptr _duplicate (IntrospectPublishers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectPublishers_Request_TypeSupportInterface () {};
                ~IntrospectPublishers_Request_TypeSupportInterface () {};
            private:
                IntrospectPublishers_Request_TypeSupportInterface (const IntrospectPublishers_Request_TypeSupportInterface &);
                IntrospectPublishers_Request_TypeSupportInterface & operator = (const IntrospectPublishers_Request_TypeSupportInterface &);
            };

            class  IntrospectPublishers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectPublishers_Request_DataWriter_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataWriter_var _var_type;

                static IntrospectPublishers_Request_DataWriter_ptr _duplicate (IntrospectPublishers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectPublishers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectPublishers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance_data) = 0;

            protected:
                IntrospectPublishers_Request_DataWriter () {};
                ~IntrospectPublishers_Request_DataWriter () {};
            private:
                IntrospectPublishers_Request_DataWriter (const IntrospectPublishers_Request_DataWriter &);
                IntrospectPublishers_Request_DataWriter & operator = (const IntrospectPublishers_Request_DataWriter &);
            };

            class  IntrospectPublishers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectPublishers_Request_DataReader_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataReader_var _var_type;

                static IntrospectPublishers_Request_DataReader_ptr _duplicate (IntrospectPublishers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance) = 0;

            protected:
                IntrospectPublishers_Request_DataReader () {};
                ~IntrospectPublishers_Request_DataReader () {};
            private:
                IntrospectPublishers_Request_DataReader (const IntrospectPublishers_Request_DataReader &);
                IntrospectPublishers_Request_DataReader & operator = (const IntrospectPublishers_Request_DataReader &);
            };

            class  IntrospectPublishers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectPublishers_Request_DataReaderView_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataReaderView_var _var_type;

                static IntrospectPublishers_Request_DataReaderView_ptr _duplicate (IntrospectPublishers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance) = 0;

            protected:
                IntrospectPublishers_Request_DataReaderView () {};
                ~IntrospectPublishers_Request_DataReaderView () {};
            private:
                IntrospectPublishers_Request_DataReaderView (const IntrospectPublishers_Request_DataReaderView &);
                IntrospectPublishers_Request_DataReaderView & operator = (const IntrospectPublishers_Request_DataReaderView &);
            };
            class IntrospectPublishers_Response_TypeSupportInterface;

            typedef IntrospectPublishers_Response_TypeSupportInterface * IntrospectPublishers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Response_TypeSupportInterface> IntrospectPublishers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Response_TypeSupportInterface> IntrospectPublishers_Response_TypeSupportInterface_out;


            class IntrospectPublishers_Response_DataWriter;

            typedef IntrospectPublishers_Response_DataWriter * IntrospectPublishers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Response_DataWriter> IntrospectPublishers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Response_DataWriter> IntrospectPublishers_Response_DataWriter_out;


            class IntrospectPublishers_Response_DataReader;

            typedef IntrospectPublishers_Response_DataReader * IntrospectPublishers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Response_DataReader> IntrospectPublishers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Response_DataReader> IntrospectPublishers_Response_DataReader_out;


            class IntrospectPublishers_Response_DataReaderView;

            typedef IntrospectPublishers_Response_DataReaderView * IntrospectPublishers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Response_DataReaderView> IntrospectPublishers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Response_DataReaderView> IntrospectPublishers_Response_DataReaderView_out;

            struct IntrospectPublishers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IntrospectPublishers_Response_, struct IntrospectPublishers_Response_Seq_uniq_> IntrospectPublishers_Response_Seq;
            typedef DDS_DCPSSequence_var < IntrospectPublishers_Response_Seq> IntrospectPublishers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectPublishers_Response_Seq> IntrospectPublishers_Response_Seq_out;

            class  IntrospectPublishers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectPublishers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectPublishers_Response_TypeSupportInterface_var _var_type;

                static IntrospectPublishers_Response_TypeSupportInterface_ptr _duplicate (IntrospectPublishers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectPublishers_Response_TypeSupportInterface () {};
                ~IntrospectPublishers_Response_TypeSupportInterface () {};
            private:
                IntrospectPublishers_Response_TypeSupportInterface (const IntrospectPublishers_Response_TypeSupportInterface &);
                IntrospectPublishers_Response_TypeSupportInterface & operator = (const IntrospectPublishers_Response_TypeSupportInterface &);
            };

            class  IntrospectPublishers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectPublishers_Response_DataWriter_ptr _ptr_type;
                typedef IntrospectPublishers_Response_DataWriter_var _var_type;

                static IntrospectPublishers_Response_DataWriter_ptr _duplicate (IntrospectPublishers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectPublishers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectPublishers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Response_& instance_data) = 0;

            protected:
                IntrospectPublishers_Response_DataWriter () {};
                ~IntrospectPublishers_Response_DataWriter () {};
            private:
                IntrospectPublishers_Response_DataWriter (const IntrospectPublishers_Response_DataWriter &);
                IntrospectPublishers_Response_DataWriter & operator = (const IntrospectPublishers_Response_DataWriter &);
            };

            class  IntrospectPublishers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectPublishers_Response_DataReader_ptr _ptr_type;
                typedef IntrospectPublishers_Response_DataReader_var _var_type;

                static IntrospectPublishers_Response_DataReader_ptr _duplicate (IntrospectPublishers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Response_& instance) = 0;

            protected:
                IntrospectPublishers_Response_DataReader () {};
                ~IntrospectPublishers_Response_DataReader () {};
            private:
                IntrospectPublishers_Response_DataReader (const IntrospectPublishers_Response_DataReader &);
                IntrospectPublishers_Response_DataReader & operator = (const IntrospectPublishers_Response_DataReader &);
            };

            class  IntrospectPublishers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectPublishers_Response_DataReaderView_ptr _ptr_type;
                typedef IntrospectPublishers_Response_DataReaderView_var _var_type;

                static IntrospectPublishers_Response_DataReaderView_ptr _duplicate (IntrospectPublishers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Response_& instance) = 0;

            protected:
                IntrospectPublishers_Response_DataReaderView () {};
                ~IntrospectPublishers_Response_DataReaderView () {};
            private:
                IntrospectPublishers_Response_DataReaderView (const IntrospectPublishers_Response_DataReaderView &);
                IntrospectPublishers_Response_DataReaderView & operator = (const IntrospectPublishers_Response_DataReaderView &);
            };
            class Sample_IntrospectPublishers_Request_TypeSupportInterface;

            typedef Sample_IntrospectPublishers_Request_TypeSupportInterface * Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Request_TypeSupportInterface> Sample_IntrospectPublishers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Request_TypeSupportInterface> Sample_IntrospectPublishers_Request_TypeSupportInterface_out;


            class Sample_IntrospectPublishers_Request_DataWriter;

            typedef Sample_IntrospectPublishers_Request_DataWriter * Sample_IntrospectPublishers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Request_DataWriter> Sample_IntrospectPublishers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Request_DataWriter> Sample_IntrospectPublishers_Request_DataWriter_out;


            class Sample_IntrospectPublishers_Request_DataReader;

            typedef Sample_IntrospectPublishers_Request_DataReader * Sample_IntrospectPublishers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Request_DataReader> Sample_IntrospectPublishers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Request_DataReader> Sample_IntrospectPublishers_Request_DataReader_out;


            class Sample_IntrospectPublishers_Request_DataReaderView;

            typedef Sample_IntrospectPublishers_Request_DataReaderView * Sample_IntrospectPublishers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Request_DataReaderView> Sample_IntrospectPublishers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Request_DataReaderView> Sample_IntrospectPublishers_Request_DataReaderView_out;

            struct Sample_IntrospectPublishers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_IntrospectPublishers_Request_, struct Sample_IntrospectPublishers_Request_Seq_uniq_> Sample_IntrospectPublishers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_IntrospectPublishers_Request_Seq> Sample_IntrospectPublishers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_IntrospectPublishers_Request_Seq> Sample_IntrospectPublishers_Request_Seq_out;

            class  Sample_IntrospectPublishers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Request_TypeSupportInterface_var _var_type;

                static Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _duplicate (Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_IntrospectPublishers_Request_TypeSupportInterface () {};
                ~Sample_IntrospectPublishers_Request_TypeSupportInterface () {};
            private:
                Sample_IntrospectPublishers_Request_TypeSupportInterface (const Sample_IntrospectPublishers_Request_TypeSupportInterface &);
                Sample_IntrospectPublishers_Request_TypeSupportInterface & operator = (const Sample_IntrospectPublishers_Request_TypeSupportInterface &);
            };

            class  Sample_IntrospectPublishers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_IntrospectPublishers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Request_DataWriter_var _var_type;

                static Sample_IntrospectPublishers_Request_DataWriter_ptr _duplicate (Sample_IntrospectPublishers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_IntrospectPublishers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_IntrospectPublishers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Request_& instance_data) = 0;

            protected:
                Sample_IntrospectPublishers_Request_DataWriter () {};
                ~Sample_IntrospectPublishers_Request_DataWriter () {};
            private:
                Sample_IntrospectPublishers_Request_DataWriter (const Sample_IntrospectPublishers_Request_DataWriter &);
                Sample_IntrospectPublishers_Request_DataWriter & operator = (const Sample_IntrospectPublishers_Request_DataWriter &);
            };

            class  Sample_IntrospectPublishers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_IntrospectPublishers_Request_DataReader_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Request_DataReader_var _var_type;

                static Sample_IntrospectPublishers_Request_DataReader_ptr _duplicate (Sample_IntrospectPublishers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Request_& instance) = 0;

            protected:
                Sample_IntrospectPublishers_Request_DataReader () {};
                ~Sample_IntrospectPublishers_Request_DataReader () {};
            private:
                Sample_IntrospectPublishers_Request_DataReader (const Sample_IntrospectPublishers_Request_DataReader &);
                Sample_IntrospectPublishers_Request_DataReader & operator = (const Sample_IntrospectPublishers_Request_DataReader &);
            };

            class  Sample_IntrospectPublishers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_IntrospectPublishers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Request_DataReaderView_var _var_type;

                static Sample_IntrospectPublishers_Request_DataReaderView_ptr _duplicate (Sample_IntrospectPublishers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Request_& instance) = 0;

            protected:
                Sample_IntrospectPublishers_Request_DataReaderView () {};
                ~Sample_IntrospectPublishers_Request_DataReaderView () {};
            private:
                Sample_IntrospectPublishers_Request_DataReaderView (const Sample_IntrospectPublishers_Request_DataReaderView &);
                Sample_IntrospectPublishers_Request_DataReaderView & operator = (const Sample_IntrospectPublishers_Request_DataReaderView &);
            };
            class Sample_IntrospectPublishers_Response_TypeSupportInterface;

            typedef Sample_IntrospectPublishers_Response_TypeSupportInterface * Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Response_TypeSupportInterface> Sample_IntrospectPublishers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Response_TypeSupportInterface> Sample_IntrospectPublishers_Response_TypeSupportInterface_out;


            class Sample_IntrospectPublishers_Response_DataWriter;

            typedef Sample_IntrospectPublishers_Response_DataWriter * Sample_IntrospectPublishers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Response_DataWriter> Sample_IntrospectPublishers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Response_DataWriter> Sample_IntrospectPublishers_Response_DataWriter_out;


            class Sample_IntrospectPublishers_Response_DataReader;

            typedef Sample_IntrospectPublishers_Response_DataReader * Sample_IntrospectPublishers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Response_DataReader> Sample_IntrospectPublishers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Response_DataReader> Sample_IntrospectPublishers_Response_DataReader_out;


            class Sample_IntrospectPublishers_Response_DataReaderView;

            typedef Sample_IntrospectPublishers_Response_DataReaderView * Sample_IntrospectPublishers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectPublishers_Response_DataReaderView> Sample_IntrospectPublishers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectPublishers_Response_DataReaderView> Sample_IntrospectPublishers_Response_DataReaderView_out;

            struct Sample_IntrospectPublishers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_IntrospectPublishers_Response_, struct Sample_IntrospectPublishers_Response_Seq_uniq_> Sample_IntrospectPublishers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_IntrospectPublishers_Response_Seq> Sample_IntrospectPublishers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_IntrospectPublishers_Response_Seq> Sample_IntrospectPublishers_Response_Seq_out;

            class  Sample_IntrospectPublishers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Response_TypeSupportInterface_var _var_type;

                static Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _duplicate (Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_IntrospectPublishers_Response_TypeSupportInterface () {};
                ~Sample_IntrospectPublishers_Response_TypeSupportInterface () {};
            private:
                Sample_IntrospectPublishers_Response_TypeSupportInterface (const Sample_IntrospectPublishers_Response_TypeSupportInterface &);
                Sample_IntrospectPublishers_Response_TypeSupportInterface & operator = (const Sample_IntrospectPublishers_Response_TypeSupportInterface &);
            };

            class  Sample_IntrospectPublishers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_IntrospectPublishers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Response_DataWriter_var _var_type;

                static Sample_IntrospectPublishers_Response_DataWriter_ptr _duplicate (Sample_IntrospectPublishers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_IntrospectPublishers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_IntrospectPublishers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_IntrospectPublishers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Response_& instance_data) = 0;

            protected:
                Sample_IntrospectPublishers_Response_DataWriter () {};
                ~Sample_IntrospectPublishers_Response_DataWriter () {};
            private:
                Sample_IntrospectPublishers_Response_DataWriter (const Sample_IntrospectPublishers_Response_DataWriter &);
                Sample_IntrospectPublishers_Response_DataWriter & operator = (const Sample_IntrospectPublishers_Response_DataWriter &);
            };

            class  Sample_IntrospectPublishers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_IntrospectPublishers_Response_DataReader_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Response_DataReader_var _var_type;

                static Sample_IntrospectPublishers_Response_DataReader_ptr _duplicate (Sample_IntrospectPublishers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Response_& instance) = 0;

            protected:
                Sample_IntrospectPublishers_Response_DataReader () {};
                ~Sample_IntrospectPublishers_Response_DataReader () {};
            private:
                Sample_IntrospectPublishers_Response_DataReader (const Sample_IntrospectPublishers_Response_DataReader &);
                Sample_IntrospectPublishers_Response_DataReader & operator = (const Sample_IntrospectPublishers_Response_DataReader &);
            };

            class  Sample_IntrospectPublishers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_IntrospectPublishers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_IntrospectPublishers_Response_DataReaderView_var _var_type;

                static Sample_IntrospectPublishers_Response_DataReaderView_ptr _duplicate (Sample_IntrospectPublishers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectPublishers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectPublishers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectPublishers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectPublishers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectPublishers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectPublishers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectPublishers_Response_& instance) = 0;

            protected:
                Sample_IntrospectPublishers_Response_DataReaderView () {};
                ~Sample_IntrospectPublishers_Response_DataReaderView () {};
            private:
                Sample_IntrospectPublishers_Response_DataReaderView (const Sample_IntrospectPublishers_Response_DataReaderView &);
                Sample_IntrospectPublishers_Response_DataReaderView & operator = (const Sample_IntrospectPublishers_Response_DataReaderView &);
            };
        }

    }

}

#endif
