// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from py_trees_ros_interfaces:srv/OpenBlackboardWatcher.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__OPEN_BLACKBOARD_WATCHER__STRUCT_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__OPEN_BLACKBOARD_WATCHER__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Request __attribute__((deprecated))
#else
# define DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Request __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct OpenBlackboardWatcher_Request_
{
  using Type = OpenBlackboardWatcher_Request_<ContainerAllocator>;

  explicit OpenBlackboardWatcher_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->filter_on_visited_path = false;
      this->with_activity_stream = false;
    }
  }

  explicit OpenBlackboardWatcher_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->filter_on_visited_path = false;
      this->with_activity_stream = false;
    }
  }

  // field types and members
  using _variables_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _variables_type variables;
  using _filter_on_visited_path_type =
    bool;
  _filter_on_visited_path_type filter_on_visited_path;
  using _with_activity_stream_type =
    bool;
  _with_activity_stream_type with_activity_stream;

  // setters for named parameter idiom
  Type & set__variables(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->variables = _arg;
    return *this;
  }
  Type & set__filter_on_visited_path(
    const bool & _arg)
  {
    this->filter_on_visited_path = _arg;
    return *this;
  }
  Type & set__with_activity_stream(
    const bool & _arg)
  {
    this->with_activity_stream = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Request
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Request
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OpenBlackboardWatcher_Request_ & other) const
  {
    if (this->variables != other.variables) {
      return false;
    }
    if (this->filter_on_visited_path != other.filter_on_visited_path) {
      return false;
    }
    if (this->with_activity_stream != other.with_activity_stream) {
      return false;
    }
    return true;
  }
  bool operator!=(const OpenBlackboardWatcher_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OpenBlackboardWatcher_Request_

// alias to use template instance with default allocator
using OpenBlackboardWatcher_Request =
  py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace py_trees_ros_interfaces

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Response __attribute__((deprecated))
#else
# define DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Response __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct OpenBlackboardWatcher_Response_
{
  using Type = OpenBlackboardWatcher_Response_<ContainerAllocator>;

  explicit OpenBlackboardWatcher_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->topic = "";
    }
  }

  explicit OpenBlackboardWatcher_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : topic(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->topic = "";
    }
  }

  // field types and members
  using _topic_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _topic_type topic;

  // setters for named parameter idiom
  Type & set__topic(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->topic = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Response
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__py_trees_ros_interfaces__srv__OpenBlackboardWatcher_Response
    std::shared_ptr<py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OpenBlackboardWatcher_Response_ & other) const
  {
    if (this->topic != other.topic) {
      return false;
    }
    return true;
  }
  bool operator!=(const OpenBlackboardWatcher_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OpenBlackboardWatcher_Response_

// alias to use template instance with default allocator
using OpenBlackboardWatcher_Response =
  py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace py_trees_ros_interfaces
{

namespace srv
{

struct OpenBlackboardWatcher
{
  using Request = py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Request;
  using Response = py_trees_ros_interfaces::srv::OpenBlackboardWatcher_Response;
};

}  // namespace srv

}  // namespace py_trees_ros_interfaces

#endif  // PY_TREES_ROS_INTERFACES__SRV__OPEN_BLACKBOARD_WATCHER__STRUCT_HPP_
